
/*This is an example of "Verification-based Test Case Generation with Loop Invariants and Method Specifications".
 This example can be tested with KeY 1.2. 
 1. Load this file into KeY and select the proof obligation for foo2().
 2. Set the Proof Search Strategy to Loop treatment=Invariant and Method treatment= Expand
 3. Set Options->Update Simplifier->Delete effectless updates = off
 4. Apply Strategy until the loop is reached.
 5. To select the branch where C(n) is invoked and to enter the loop invariant proceed as follows:
   5.1 Right-click on the formula consisting of the update, loop, and postcondition; and select the while_invariant rule. An instantiation window will popup.
   5.2 In the instantiation window enter the modfier set {i,n} and the 
   invariant (i+4)/(1+n-oldN)=4. 
   5.3 Apply Strategy on the Body Preserves Invariant branch until no more rules can be applied to the branch where the if-statement is executed
   5.4 Right-click on the last node of the branch where C(n) was executed in the Proof tree and select Create Test for Node. A message will popup telling you where the JUnit test was saved.*/
public class BranchingLoop{

	/*@public  normal_behavior
	@ ensures true;
	@*/
	public void foo2(int n){
	  int i=0; 
	  int oldN = n;
	/* loop_invariant (i+4)/(1+n-oldN)=4*/
	  while(i < n*2){ 
	    n+=2;
	    if(i>=64){ 
	      C(n); //NOP 
	    }
	    i+=8; 
	  }
	}

	public void C(int n){
		//dummy
	}

}
